.486
.MODEL flat, stdcall

OPTION CASEMAP:NONE   ;Case sensitive

Include \masm32\include\windows.inc
Include	\masm32\include\user32.inc
Include \masm32\include\kernel32.inc
Include	\masm32\macros\macros.asm
Include \masm32\include\masm32.inc

IncludeLib \masm32\lib\kernel32.lib
IncludeLib \masm32\lib\masm32.lib

;Declare WIN32 API Functions
AllocConsole				PROTO
FreeConsole				PROTO
PutOut					PROTO
GetStdHandle				PROTO :DWORD
WriteFile					PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD				
ExitProcess				PROTO :DWORD

.data
hConsoleOut	dd 	0h
hConsoleIn	dd	0h
textAddr		dd	0h
bytesIn		dd 	0h
bytesOut   	dd 	0h
msgpAttach	db	"DLL_Process_Attach Msg",10,0
msgpDettach	db	"DLL_Process_Detach Msg",10,0
msgtAttach	db	"DLL_Thread_Attach Msg",10,0
msgtDettach	db	"DLL_Thread_Detach Msg",10,0
msgInitODBC	db	"InitODBC Called",10,0

.data	
recdsIn		db	?
Event		db	?

.code
LibMain Proc hInstDLL:DWORD, reason:DWORD, unused: DWORD
	cmp		reason,0h					;DLL_PROCESS_DETACH  ?
	jne		reason_1h					;No, check for other reasons
	;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	; CLEANUP ODBC CONNECTION HERE !                                                        +
	;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	lea		eax,msgpDettach				;Set msg to print
	call		PutOut						;PrintMsg
	push	ENABLE_PROCESSED_INPUT	;Set Flag
	push	ENABLE_ECHO_INPUT			;Set Flag
	push	ENABLE_LINE_INPUT			;Set flag
	push	hConsoleIn					;Console Instance
	call		SetConsoleMode				;Set Console = INPUT
	lea		eax,recdsIn					;eax -> input buffer
	push	eax							;Add to parmlist
	push	1							;# Bytes to Read
	lea		eax,Event						;eax -> Event
	push	eax							;Add to parmlist
	push	hConsoleIn					;Console Instance
	call		ReadConsoleInput				;ReadConsole Keystroke
	call		FreeConsole					;FreeConsole 
	push 	0							;Add RC to parmlist
	call 		ExitProcess					;Exit Routine
	jmp		ODBC_Main_Exit				;Leave ODBC_Main
reason_1h:
	cmp		reason,1h					;DLL_PROCESS_ATTACH?
	jne		reason_2h					;No, check  for other reasons
	;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	;STARTUP ODBC CONNECTION HERE !                                                         +
	;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	call		AllocConsole					;Allocate Console for Output
	push	STD_INPUT_HANDLE			;Standard Input Handle
	call		GetStdHandle					;Call WIN32 API for Handle
	mov		hConsoleIn,eax				;Save STD_INPUT_HANDLE 
	lea		eax,msgpAttach				;Set msg to print
	call		PutOut						;PrintMsg
	jmp		ODBC_Main_Exit				;Leave ODBC_Main
reason_2h:
	cmp		reason,2h					;DLL_THREAD_ATTACH?
	jne		reason_3h					;No, check  for other reasons
	lea		eax,msgtAttach					;Set msg to print
	call		PutOut						;PrintMsg
	jmp		ODBC_Main_Exit				;Leave ODBC_Main
reason_3h:
	cmp		reason,3h					;DLL_THREAD_DETACH?
	jne		ODBC_Main_Exit				;No, Process DLL_PROCESS_DETACH
	lea		eax,msgtDettach				;Set msg to print
	call		PutOut						;PrintMsg
ODBC_Main_Exit:						
	mov		eax,1h						;EAX = TRUE
	Ret									;Exit Proc

ret
LibMain EndP
PutOut     Proc

	mov		textAddr,eax					;Copy address of Text

;+++++++++ Call StrLen for length of Text +++++++++
	mov		eax,textAddr					;eax = addr of Text
	push	eax							;Add to parmlist
	call		StrLen						;Figure length
	mov		ecx,eax						;move length to ecx
;+++++++++++++++++++++++++++++++++++++++

	push 	0h							; NULL Parameter
	lea		eax,bytesOut					;eax =  Addr of bytesOut
	push 	eax							;Add to parmlist
	push	ecx							;ecx = length
	mov		eax,textAddr					;eax -> Address of Text to print
	push 	eax							;Add to parmlist
	push 	hConsoleOut					;Std Output Handle
	call 		WriteFile						;Write Output
	mov 		eax, bytesOut					;Save # bytes written
Ret
PutOut	EndP

ODBCInit  Proc 

;+++++++++++++++++++++++++++++++++++++++++++
;  Based on StdOut in C:\m32lib\stdout.asm                     +
;+++++++++++++++++++++++++++++++++++++++++++

lea		eax,msgInitODBC					;eax -> msgInitODBC
push	eax								;Add to parmlist
call		PutOut							;Print the number

ret
ODBCInit	EndP

END										;End MAIN							